/**
 * See license.txt
 */
   
/******************************************************************************
 * Interface for describing an icon pack image.  The component that
 * implements this interface should not be called directly, but instead
 * gotten from the pack interface.
 * 
 * @status    FROZEN
 * @version   1.0
 ******************************************************************************/
function IconItem() 
{
  this._properties = {}; 
}
IconItem.prototype = {
  __proto__:  new ItemBase("IconItem"),
            
  ////////////////////////////////
  // ffIIconItem
  
  /**
   * Unique ID of the icon.  Combination of its index and
   * size properties.  Seperated with a hyphen.
   */
  get ID() { return this.index + "-" + this.size; },
                  
  /**
   * URL to the specific image.
   */
  get URL() { return this.getProperty("URL"); },
  
  /**
   * Width of the image.
   */
  get width() { return this.getProperty("width"); },
  
  /**
   * Height of the image.
   */
  get height() { return this.getProperty("height"); },
  
  /**
   * Size of the icon (large/small).
   */
  get size() { return this.getProperty("size"); },
  
  /**
   * Index of the image.  Index returned by the webservice to describe
   * the weather conditions.
   */
  get index() { return this.getProperty("index"); },
  
  /**
   * Image is an exemption icon.
   */
  get isExemption() { return this.getProperty("isExemption"); }
};